#include <iostream>
#include "TestCase.h"

// You must #include all of your test cases here.
#include "MyTestCase.h"

int main(int argc, char *argv[])
{
  TestResults results;

  // We accept a single optional command line argument which allows the
  // user to run just a single test by giving it's name like "MyTestCase::FirstTest"
  std::string testname = "";
  if (argc == 2) {
    testname = argv[1];
  }

  // Run all the tests in MyTestCase and add results to 'results'
  RUN_TESTS(results, MyTestCase, testname);

  bool ok = true;

  // Now look at 'results' and dump some information to the screen.
  for (int i=0; i < results.size(); i++) {
    if (!results[i].m_passed) { 
      cout << "Class " << results[i].m_classname;
      cout << " method " << results[i].m_method;
      cout << " failed with " << results[i].m_text << endl;
      cout << endl;
      ok = false;
    }
  }

  if (results.size() == 0) {
    cout << "No tests run!" << endl;
  } else if (ok) {
    cout << "OK (" << results.size() << " tests run)" << endl;
  } else {
    cout << "FAILED" << endl;
  }
}
