#include "TestCase.h"
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

void TestCase::assertImplementation(bool condition, std::string text)
{
  if (!condition) {
    std::string s;
    s = "failed assertion of " + text;
    throw FailedTestException(s);
  }
}

void TestCase::checkOutput(std::string tmp, std::string expected)
{
  std::string output_dir = "regression_output/";
  std::string expected_path = output_dir + expected;

  mkdir(output_dir.c_str(), 0755);

  struct stat buffer;
  if (stat(expected_path.c_str(), &buffer)) {
    std::string s;
    s = "Could open expected output file " + expected_path +
      " so created it from this tests output.  Please check for correctness";
    std::string cmd = "cp " + tmp + " " + expected_path;
    system(cmd.c_str());
    throw FailedTestException(s);
  }

  std::string cmd = "diff " + tmp + " " + expected_path + " > /dev/null";
  
  if (system(cmd.c_str()) == 0) {
    // no difference
    return;
  } else {
    // difference found
    std::string s = "Difference in output found between " + tmp +
      " and " + expected_path;
    throw FailedTestException(s);
  }
}
